		------------------------------------
	
	signal en:                     STD_LOGIC_VECTOR(3 downto 0); -- BlockRAM enables
	signal do0l, do1l, do2l, do3l: STD_LOGIC_VECTOR(7 downto 0); -- BlockRAM data (low)
	signal do0h, do1h, do2h, do3h: STD_LOGIC_VECTOR(7 downto 0); -- BlockRAM data (high)
	alias  dil:                    STD_LOGIC_VECTOR(7 downto 0) is di(7 downto 0);
	alias  dih:                    STD_LOGIC_VECTOR(7 downto 0) is di(15 downto 8);
	signal addr2:                  STD_LOGIC_VECTOR(addr'range);
begin
	--	component ramb4_s8
	--	port(
	--		DI : in std_logic_vector(7 downto 0);
	--		EN : in std_ulogic;
	--		WE : in std_ulogic;
	--		RST : in std_ulogic;
	--		CLK : in std_ulogic;
	--		ADDR : in std_logic_vector(8 downto 0);
	--		DO : out std_logic_vector(7 downto 0));
	--	end component;
	
	-- *** edit U0..U7 generics to simulate ROM! ***
	
	-- big endian: even address, bits (15 downto 0)
	U0: RAMB4_S8 port map(	DI=> dih, EN=> en(0), WE=> weh, RST=> rst, CLK=> clk, ADDR=> addr(9 downto 1), DO=> do0h);
	U1: RAMB4_S8 port map(	DI=> dih, EN=> en(1), WE=> weh, RST=> rst, CLK=> clk, ADDR=> addr(9 downto 1), DO=> do1h);
	U2: RAMB4_S8 port map(	DI=> dih, EN=> en(2), WE=> weh, RST=> rst, CLK=> clk, ADDR=> addr(9 downto 1), DO=> do2h);
	U3: RAMB4_S8 port map(	DI=> dih, EN=> en(3), WE=> weh, RST=> rst, CLK=> clk, ADDR=> addr(9 downto 1), DO=> do3h);
	-- big endian: odd address, bits (7 downto 8)
	U4: RAMB4_S8 port map(	DI=> dil, EN=> en(0), WE=> wel, RST=> rst, CLK=> clk, ADDR=> addr(9 downto 1), DO=> do0l);
	U5: RAMB4_S8 port map(	DI=> dil, EN=> en(1), WE=> wel, RST=> rst, CLK=> clk, ADDR=> addr(9 downto 1), DO=> do1l);
	U6: RAMB4_S8 port map(	DI=> dil, EN=> en(2), WE=> wel, RST=> rst, CLK=> clk, ADDR=> addr(9 downto 1), DO=> do2l);
	U7: RAMB4_S8 port map(	DI=> dil, EN=> en(3), WE=> wel, RST=> rst, CLK=> clk, ADDR=> addr(9 downto 1), DO=> do3l);
	
	process(clk, rst)
	begin
		if rst= '1' then
		elsif rising_edge(clk) then
			addr2<= addr;
		end if;
	end process;
	
	with addr2(11 downto 10) select do<=
	do0h & do0l when "00",
	do1h & do1l when "01",
	do2h & do2l when "10",
	do3h & do3l when others;
	
	with addr(11 downto 10) select en<=
	"0001" when "00",
	"0010" when "01",
	"0100" when "10",
	"1000" when others;
	
end architecture;

--------------------------------------------------------------------------------
-- end of file
